<?php

/**
 * we-Tag we:lesscss
 *
 * @author Thomas Göbe (goebe@twinsystems.de)
 */
function we_tag_lesscss($attribs){
	// check mandatory attributes
	if(($missingAttrib = attributFehltError($attribs, "id", __FUNCTION__))){
		print $missingAttrib;
		return "";
	}
	if(($missingAttrib = attributFehltError($attribs, "target", __FUNCTION__))){
		print $missingAttrib;
		return "";
	}

	// get attributes
	$id = weTag_getAttribute("id", $attribs);
	$target = weTag_getAttribute("target", $attribs);
	$watch = weTag_getAttribute("watch", $attribs,false,true);
	$forceUpdate = weTag_getAttribute("forceUpdate", $attribs,false,true);
	$formatter = weTag_getAttribute("formatter", $attribs,'lessjs');
	$preserveComments = weTag_getAttribute("comments", $attribs,false,true);

	$doUpdate = $forceUpdate;

	// do we have to watch the filedate?
	if ($watch) {
		$cssObject = new we_textDocument();
		$cssObject->initByID($target);

		$lessObject = new we_textDocument();
		$lessObject->initByID($id);

		$cssTime = $cssObject->Published;
		$lessTime = $lessObject->Published;

		if ($cssTime < $lessTime) {
			$doUpdate = true;
		}
	}

	if ($doUpdate) {
		require_once('lessc.inc.php');
		
		// use initialized object from watch check if possible
		if (!isset($cssObject)) {
			$cssObject = new we_textDocument();
			$cssObject->initByID($target);
			
			$lessObject = new we_textDocument();
			$lessObject->initByID($id);
		}
		
		$less = new lessc;
		$less->setFormatter($formatter);
		$less->setPreserveComments($preserveComments);

		try {
			$result = $less->compileFile($_SERVER['DOCUMENT_ROOT'].$lessObject->Path);
			$cssObject->setElement('data', $result);
			$cssObject->we_save();
		} catch (exception $e) {
			echo "fatal error: " . $e->getMessage();
		}
	}

	$cssObject = null;
	$lessObject = null;

	// set attributes for we:css
	$attribs['id'] = $attribs['target'];	
	$remove = array('watch','forceUpdate','target','comments','formatter');
	$attribs = removeAttribs($attribs,$remove);

	return we_tag('css',$attribs);
}
